"""
This module defines channels to easily log messages conforming to well-known Foxglove schemas.

See the :py:mod:`foxglove.schemas` module for available definitions.
"""

# Generated by https://github.com/foxglove/foxglove-sdk
from foxglove._foxglove_py.channels import (
    ArrowPrimitiveChannel,
    CameraCalibrationChannel,
    CircleAnnotationChannel,
    ColorChannel,
    CompressedImageChannel,
    CompressedVideoChannel,
    CubePrimitiveChannel,
    CylinderPrimitiveChannel,
    FrameTransformChannel,
    FrameTransformsChannel,
    GeoJsonChannel,
    GridChannel,
    ImageAnnotationsChannel,
    KeyValuePairChannel,
    LaserScanChannel,
    LinePrimitiveChannel,
    LocationFixChannel,
    LogChannel,
    ModelPrimitiveChannel,
    PackedElementFieldChannel,
    Point2Channel,
    Point3Channel,
    PointCloudChannel,
    PointsAnnotationChannel,
    PoseChannel,
    PoseInFrameChannel,
    PosesInFrameChannel,
    QuaternionChannel,
    RawAudioChannel,
    RawImageChannel,
    SceneEntityChannel,
    SceneEntityDeletionChannel,
    SceneUpdateChannel,
    SpherePrimitiveChannel,
    TextAnnotationChannel,
    TextPrimitiveChannel,
    TriangleListPrimitiveChannel,
    Vector2Channel,
    Vector3Channel,
)

__all__ = [
    "ArrowPrimitiveChannel",
    "CameraCalibrationChannel",
    "CircleAnnotationChannel",
    "ColorChannel",
    "CompressedImageChannel",
    "CompressedVideoChannel",
    "CubePrimitiveChannel",
    "CylinderPrimitiveChannel",
    "FrameTransformChannel",
    "FrameTransformsChannel",
    "GeoJsonChannel",
    "GridChannel",
    "ImageAnnotationsChannel",
    "KeyValuePairChannel",
    "LaserScanChannel",
    "LinePrimitiveChannel",
    "LocationFixChannel",
    "LogChannel",
    "ModelPrimitiveChannel",
    "PackedElementFieldChannel",
    "Point2Channel",
    "Point3Channel",
    "PointCloudChannel",
    "PointsAnnotationChannel",
    "PoseChannel",
    "PoseInFrameChannel",
    "PosesInFrameChannel",
    "QuaternionChannel",
    "RawAudioChannel",
    "RawImageChannel",
    "SceneEntityChannel",
    "SceneEntityDeletionChannel",
    "SceneUpdateChannel",
    "SpherePrimitiveChannel",
    "TextAnnotationChannel",
    "TextPrimitiveChannel",
    "TriangleListPrimitiveChannel",
    "Vector2Channel",
    "Vector3Channel",
]
